﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using System.Windows.Forms;

namespace InstallService
{
    public partial class Form1 : Form
    {

        private string serviceName = "";
        ServiceController[] services = null;
        bool isbn = false;
        OpenFileDialog ofd = new OpenFileDialog();
        public Form1()
        {
            InitializeComponent();

            this.Load += Form1_Load;

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            serviceName = System.Configuration.ConfigurationManager.AppSettings["ServiceName"].ToString();
            services = ServiceController.GetServices();
            if (IsServerExists(serviceName))
            {
                btn_Install.Enabled = false;
                btn_Uninstall.Enabled = true;
                btn_startService.Enabled = true;
                btn_stopService.Enabled = true;
            }
            else
            {
                btn_Install.Enabled = true;
                btn_Uninstall.Enabled = false;
                btn_startService.Enabled = false;
                btn_stopService.Enabled = false;
            }
        }

        private void btn_Install_Click(object sender, EventArgs e)
        {

            if (IsServerExists(serviceName))
            {
                btn_Install.Enabled = false;
                btn_Uninstall.Enabled = true;
                return;
            }
            else
            {
                btn_Install.Enabled = true;
                btn_Uninstall.Enabled = false;
                InstallFw();

            }
        }

        private bool IsServerExists(string name)
        {
            isbn = false;
            try
            {
                foreach (ServiceController service in services)
                {
                    if (service.ServiceName.ToUpper() == name.ToUpper())
                    {
                        isbn = true;
                        break;
                    }
                }
                return isbn;
            }
            catch (Exception ex)
            {
                return false;
            }

        }

        private void InstallFw()
        {

            if (ofd.ShowDialog() == DialogResult.OK)
            {

                txt_filePath.Text = ofd.FileName;

            }
            else
            {
                MessageBox.Show("没有选择要安装的服务！");
                return;
            }

            string strCMD = @"InstallUtil.exe " + txt_filePath.Text;

            string output = excuteCmd(strCMD);

            MessageBox.Show(output);
        }

        private void UnInstallFw()
        {

            if (ofd.ShowDialog() == DialogResult.OK)
            {

                txt_filePath.Text = ofd.FileName;

            }
            else
            {
                MessageBox.Show("没有选择要卸载的文件！");
                return;
            }
            string strCMD = @"InstallUtil.exe /u " + txt_filePath.Text;

            string output = excuteCmd(strCMD);

            MessageBox.Show(output);
        }

        private void btn_Uninstall_Click(object sender, EventArgs e)
        {
            if (IsServerExists(serviceName))
            {
                btn_Install.Enabled = false;
                btn_Uninstall.Enabled = true;
                UnInstallFw();
            }
            else
            {
                btn_Install.Enabled = true;
                btn_Uninstall.Enabled = false;
                return;

            }

        }

        private string excuteCmd(string strCMD)
        {

            Process p = new Process();
            p.StartInfo.FileName = "cmd.exe";
            p.StartInfo.UseShellExecute = false;//是否使用操作系统shell启动
            p.StartInfo.RedirectStandardInput = true;//接受来自调用程序的输入信息
            p.StartInfo.RedirectStandardOutput = true;//由调用程序获取输出信息
            p.StartInfo.RedirectStandardError = true;//重定向标准错误输出
            p.StartInfo.WorkingDirectory = @"C:\Windows\Microsoft.NET\Framework\v2.0.50727";

            //p.StartInfo.CreateNoWindow = true;
            //p.StartInfo.WindowStyle = ProcessWindowStyle.Normal;
            p.Start();//启动程序
            //string strCMD = @"InstallUtil.exe /u " + txt_filePath.Text;
            //向cmd窗口发送输入信息
            p.StandardInput.WriteLine(strCMD);
            p.StandardInput.AutoFlush = true;
            p.StandardInput.WriteLine(" exit");
            p.StandardInput.AutoFlush = true;


            //获取cmd窗口的输出信息
            string output = p.StandardOutput.ReadToEnd();
            //等待程序执行完退出进程
            p.WaitForExit();
            p.Close();

            return output;
        }

        private void btn_startService_Click(object sender, EventArgs e)
        {
            if (!IsServerExists(serviceName))
            {
                MessageBox.Show("未找到配置文件写的服务：" + serviceName);
                return;
            }
            bool isStarted = false;
            ServiceController star_service = new ServiceController(serviceName);
            if (star_service.Status != ServiceControllerStatus.Running &&
star_service.Status != ServiceControllerStatus.StartPending)
            {
                star_service.Start();

                for (int i = 0; i < 80; i++)
                {
                    star_service.Refresh();
                    System.Threading.Thread.Sleep(1000);
                    if (star_service.Status == ServiceControllerStatus.Running)
                    {
                        isStarted = true;
                        break;
                    }
                    if (i == 79)
                    {
                        isStarted = false;
                    }
                }
            }
            else
            {
                MessageBox.Show("服务已经启动或被暂停");
                return;
            }
            if (isStarted)
            {
                MessageBox.Show("服务启动完成!");
            }
            else
            {
                MessageBox.Show("服务未在80秒内启动起来，请到服务里去手动启动");
            }

        }

        private void btn_stopService_Click(object sender, EventArgs e)
        {

            if (!IsServerExists(serviceName))
            {
                MessageBox.Show("未找到配置文件写的服务：" + serviceName);
                return;
            }
            bool isStoped = false;
            ServiceController star_service = new ServiceController(serviceName);
            if (star_service.Status == ServiceControllerStatus.Running)
            {
                star_service.Stop();

                for (int i = 0; i < 80; i++)
                {
                    star_service.Refresh();
                    System.Threading.Thread.Sleep(1000);
                    if (star_service.Status == ServiceControllerStatus.Stopped)
                    {
                        isStoped = true;
                        break;
                    }
                    if (i == 79)
                    {
                        isStoped = false;
                    }
                }
            }
            else
            {
                MessageBox.Show("服务已经启动或被暂停");
                return;
            }
            if (isStoped)
            {
                MessageBox.Show("服务停止成功!");
            }
            else
            {
                MessageBox.Show("服务未在80秒内停止，请到服务里去手动停止");
            }
        }
    }
}

